glibmm: Gio::Credentials Class Reference

glibmm 2.33.14

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Credentials Class Reference

An object containing credentials. More...

`#include <giomm/credentials.h>`

Inheritance diagram for Gio::Credentials:
[legend]

## Public Member Functions
virtual | ~Credentials ()
GCredentials* | gobj ()
| Provides access to the underlying C GObject.
const GCredentials* | gobj () const
| Provides access to the underlying C GObject.
GCredentials* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | to_string () const
| Creates a human-readable textual representation of credentials that can be used in logging and debug messages.
gpointer | get_native (CredentialsType native_type)
| Gets a pointer to native credentials of type native_type from credentials.
void | set_native (CredentialsType native_type, gpointer native)
| Copies the native credentials of type native_type from native into credentials.
bool | is_same_user (const Glib::RefPtr< const Credentials >& other_credentials)
| Checks if credentials and other_credentials is the same user.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj ()
| Provides access to the underlying C GObject.
const GObject* | gobj () const
| Provides access to the underlying C GObject.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Credentials > | create ()

## Protected Member Functions
| Credentials ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Credentials > | wrap (GCredentials* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

An object containing credentials.

The Credentials type is a reference-counted wrapper for native credentials. This information is typically used for identifying, authenticating and authorizing other processes.

Some operating systems supports looking up the credentials of the remote peer of a communication endpoint - see e.g. Gio::Socket::get_credentials().

Some operating systems supports securely sending and receiving credentials over a Unix Domain Socket, see UnixCredentialsMessage, Gio::UnixConnection::send_credentials() and Gio::UnixConnection::receive_credentials() for details.

On Linux, the native credential type is a struct ucred - see the unix(7) man page for details. This corresponds to Gio::CREDENTIALS_TYPE_LINUX_UCRED.

On FreeBSD, the native credential type is a struct cmsgcred. This corresponds to Gio::CREDENTIALS_TYPE_FREEBSD_CMSGCRED.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::Credentials::~Credentials | ( |  | ) |
| virtual

Gio::Credentials::Credentials | ( |  | ) |
| protected

## Member Function Documentation

static Glib::RefPtr<Credentials> Gio::Credentials::create | ( |  | ) |
| static

gpointer Gio::Credentials::get_native | ( | CredentialsType | native_type | ) |

Gets a pointer to native credentials of type native_type from credentials.

It is a programming error (which will cause an warning to be logged) to use this method if there is no Credentials support for the OS or if native_type isn't supported by the OS.

Since glibmm 2.26:

Parameters

  native_type | The type of native credentials to get.

Returns
  The pointer to native credentials or `0` if the operation there is no Credentials support for the OS or if native_type isn't supported by the OS. Do not free the returned data, it is owned by credentials.

static GType Gio::Credentials::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GCredentials* Gio::Credentials::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GCredentials* Gio::Credentials::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GCredentials* Gio::Credentials::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::Credentials::is_same_user | ( | const Glib::RefPtr< const Credentials >& | other_credentials | ) |

Checks if credentials and other_credentials is the same user.

This operation can fail if Credentials is not supported on the the OS.

Since glibmm 2.26:

Parameters

  other_credentials | A Credentials.

Returns
  `true` if credentials and other_credentials has the same user, `false` otherwise or if error is set.

void Gio::Credentials::set_native | ( | CredentialsType | native_type,
|  | gpointer | native
| ) |  |

Copies the native credentials of type native_type from native into credentials.

It is a programming error (which will cause an warning to be logged) to use this method if there is no Credentials support for the OS or if native_type isn't supported by the OS.

Since glibmm 2.26:

Parameters

  native_type | The type of native credentials to set.
  native | A pointer to native credentials.

Glib::ustring Gio::Credentials::to_string | ( |  | ) | const

Creates a human-readable textual representation of credentials that can be used in logging and debug messages.

The format of the returned string may change in future GLib release.

Since glibmm 2.26:

Returns
  A string that should be freed with Glib::free().

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Credentials > wrap | ( | GCredentials * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.